=== bindings/CMakeLists.txt ===
if (SC_PSYCOLLIDER)
	add_subdirectory(PySCLang)
endif()
