=== debian/changelog ===
supercollider (1:3.5.3~repack-3) unstable; urgency=low

  * Avoid FTBFS in PowerPC
  * Avoid FTBFS in ia64
  * Fix ARM FTBFS: more qreal->double assumptions. Closes: #682361

 -- Felipe Sateler <fsateler@debian.org>  Sat, 28 Jul 2012 20:19:58 -0400

supercollider (1:3.5.3~repack-2) unstable; urgency=low

  [ Dan Stowell ]
  * Fix build on ia64 - avoid invoking unneeded perf_counter.hpp
  * Fix caps in supercollider-emacs remove script. Closes: #681187
  * Boost-atomic build fix for PPC
  * Note copyright for file adapted from wmctrl project
  * Strip accidental gremlin characters that can cause problems for users in
    some locales

  [ Felipe Sateler ]
  * Fix FTBFS in big endian architectures
  * Fix FTBFS in arm* architectures

 -- Dan Stowell <danstowell@users.sourceforge.net>  Thu, 12 Jul 2012 22:53:55 +0100

supercollider (1:3.5.3~repack-1) unstable; urgency=low


  [ Dan Stowell ]
  * Imported upstream version 3.5.3
   -  Removed 3 patches now upstreamed
   - Repack upstream source without boost sources
  * Fix build on non-x86/64: define BOOST_LOCKFREE_DCAS_ALIGNMENT
      (Update prefix.hpp to current boost SVN 2012-07-03)

  [ Jonas Smedegaard ]
  * Unfuzz patch and refresh with shortening options.
  * Revive copyright/license tracking silently dropped in 1:3.5.1-1.

  [ Felipe Sateler ]
  * Add missing epoch to versioned breaks/replaces. Closes: #679705
  * Install README.extensions via debian/rules instead of a patch
  * Add DEP3 header to update_boostlockfree_prefixhpp.patch
  * Remove unused License paragraph
  * Bump Standards-Version (no changes needed)
  * Remove unused lintian override package-contains-empty-directory
  * Update copyright hints file

 -- Felipe Sateler <fsateler@debian.org>  Sat, 07 Jul 2012 14:16:59 -0400
