=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_DH_INSTALL_SOURCEDIR=debian/tmp

# # Add here any variable or target overrides you need.

DEB_INSTALL_DOCS_supercollider             = README_LINUX.txt README.txt
DEB_INSTALL_DOCS_supercollider-server      = README_LINUX.txt README.txt
DEB_INSTALL_DOCS_supercollider-emacs       = editors/scel/README
DEB_INSTALL_DOCS_supercollider-vim         = editors/scvim/README editors/scvim/SCVim.scd
DEB_INSTALL_DOCS_supercollider-gedit       = editors/sced/README

DEB_INSTALL_MANPAGES_supercollider-server  = debian/scsynth.1
DEB_INSTALL_MANPAGES_supercollider-supernova = debian/supernova.1
DEB_INSTALL_MANPAGES_supercollider         = debian/sclang.1
DEB_INSTALL_MANPAGES_supercollider-vim     = debian/scvim.1 debian/sclangpipe_app.1

DEB_CMAKE_EXTRA_FLAGS = -DDSO_VISIBILITY=on -DSUPERNOVA=on -DSC_EL_BYTECOMPILE=OFF

# Exclude external libs from the source package if unused on linux or using system-supplied
DEB_UPSTREAM_REPACKAGE_EXCLUDES = \
				  external_libraries/boost/ \
				  external_libraries/curl/ \
				  external_libraries/libsndfile/ \
				  external_libraries/sndfile.hh \
				  external_libraries/simplejson-*/ \
				  external_libraries/icu
DEB_UPSTREAM_URL = http://prdownloads.sourceforge.net/supercollider
DEB_UPSTREAM_TARBALL_BASENAME_MANGLE = s/supercollider(.*)/SuperCollider$$1-Source-linux/
DEB_UPSTREAM_TARBALL_EXTENSION = tar.bz2
DEB_UPSTREAM_TARBALL_SRCDIR = SuperCollider-Source
DEB_UPSTREAM_TARBALL_MD5 = 84fde920c32e9644902f989136a35b91
DEB_UPSTREAM_REPACKAGE_TAG = repack

binary-fixup/supercollider-common::
	dh_linktree -psupercollider-common

install/supercollider-common::
	install -m 644 debian/README.extensions \
		$(DEB_DH_INSTALL_SOURCEDIR)/usr/share/SuperCollider/Extensions/README

install/supercollider-emacs::
	install -d $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications
	install -m 644 debian/scel.desktop $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications

install/supercollider-vim::
	install -d $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications
	install -m 644 debian/scvim.desktop $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications
