=== debian/watch ===
version=3

#opts=dversionmangle=s/\.\d~\w+$//,uversionmangle=s/RC\d+$// \
#  http://sf.net/supercollider/SuperCollider-(.*)\-Source.tar\.gz

# better manglers, provided by Dan Stowell
opts=dversionmangle=s/\.\d~\w+$//,uversionmangle=s/([a-zA-Z]+)/~$1/ \
  http://sf.net/supercollider/SuperCollider-(.*)\-Source-linux\.tar\.gz
